## gr-fcdproplus 3.7.25.4b6464b

=== CMakeLists.txt ===
# Copyright 2011-2014 Free Software Foundation, Inc.
#
# This file is part of GNU Radio
#
# GNU Radio is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 3, or (at your option)
# any later version.
#
# GNU Radio is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with GNU Radio; see the file COPYING.  If not, write to
# the Free Software Foundation, Inc., 51 Franklin Street,
# Boston, MA 02110-1301, USA.


########################################################################
# Project setup
########################################################################
########################################################################
#
# First look in the install directory for package config of gnuradio
#
########################################################################
set( ENV{PKG_CONFIG_PATH} "${CMAKE_INSTALL_PREFIX}/lib/pkgconfig:$ENV{PKG_CONFIG_PATH}")


cmake_minimum_required(VERSION 3.0)
project(gr-fcdproplus CXX C)

#select the release build type by default to get optimization flags
if(NOT CMAKE_BUILD_TYPE)
   set(CMAKE_BUILD_TYPE "Release")
   message(STATUS "Build type not specified: defaulting to release.")
endif(NOT CMAKE_BUILD_TYPE)
set(CMAKE_BUILD_TYPE ${CMAKE_BUILD_TYPE} CACHE STRING "")


########################################################################
# Compiler specific setup
########################################################################
if(CMAKE_COMPILER_IS_GNUCXX AND NOT WIN32)
    #http://gcc.gnu.org/wiki/Visibility
    add_definitions(-fvisibility=hidden)
endif()
########################################################################
# Find boost
########################################################################
if(UNIX AND EXISTS "/usr/lib64")
    list(APPEND BOOST_LIBRARYDIR "/usr/lib64") #fedora 64-bit fix
endif(UNIX AND EXISTS "/usr/lib64")
set(Boost_ADDITIONAL_VERSIONS
    "1.35.0" "1.35" "1.36.0" "1.36" "1.37.0" "1.37" "1.38.0" "1.38" "1.39.0" "1.39"
    "1.40.0" "1.40" "1.41.0" "1.41" "1.42.0" "1.42" "1.43.0" "1.43" "1.44.0" "1.44"
    "1.45.0" "1.45" "1.46.0" "1.46" "1.47.0" "1.47" "1.48.0" "1.48" "1.49.0" "1.49"
    "1.50.0" "1.50" "1.51.0" "1.51" "1.52.0" "1.52" "1.53.0" "1.53" "1.54.0" "1.54"
    "1.55.0" "1.55" "1.56.0" "1.56" "1.57.0" "1.57" "1.58.0" "1.58" "1.59.0" "1.59"
    "1.60.0" "1.60" "1.61.0" "1.61" "1.62.0" "1.62" "1.63.0" "1.63" "1.64.0" "1.64"
    "1.65.0" "1.65" "1.66.0" "1.66" "1.67.0" "1.67" "1.68.0" "1.68" "1.69.0" "1.69"
)
find_package(Boost "1.35" COMPONENTS filesystem system)

if(NOT Boost_FOUND)
    message(FATAL_ERROR "Boost required to compile fcdproplus")
endif()

########################################################################
# Find gnuradio build dependencies
########################################################################
set(GR_REQUIRED_COMPONENTS RUNTIME PMT BLOCKS AUDIO)
find_package(Gnuradio "3.7" REQUIRED PATHS ${CMAKE_INSTALL_PREFIX} NO_DEFAULT_PATH)
if(NOT GNURADIO_RUNTIME_FOUND)
    message(FATAL_ERROR "GnuRadio Core required to compile fcdproplus")
endif()
FIND_LIBRARY(HIDAPI_LIBRARY hidapi-libusb)
########################################################################
#
# set search path for cmake modules to OOT, Gnuradio
#
########################################################################
set( CMAKE_MODULE_PATH "${CMAKE_SOURCE_DIR}/cmake/Modules")
include(FindGnuradioModules)

if(${GNURADIO_MODULE_DIRECTORY} STREQUAL "GNURADIO_MODULE_DIRECTORY-NOTFOUND")
	message(FATAL_ERROR "Cannot find gnuradio cmake Modules directory")
else()
	message(STATUS "Modules found in ${GNURADIO_MODULE_DIRECTORY}")
endif()	
list(APPEND CMAKE_MODULE_PATH "${GNURADIO_MODULE_DIRECTORY}" )

# Set the version information here
set(VERSION_INFO_MAJOR_VERSION 3)
set(VERSION_INFO_API_COMPAT    7)
set(VERSION_INFO_MINOR_VERSION 2)
set(VERSION_INFO_MAINT_VERSION 0)
include(GrVersion) #setup version info
########################################################################
# Install directories
########################################################################
include(GrPlatform) #define LIB_SUFFIX
set(GR_RUNTIME_DIR      bin)
set(GR_LIBRARY_DIR      lib${LIB_SUFFIX})
set(GR_INCLUDE_DIR      include/fcdproplus)
set(GR_DATA_DIR         share)
set(GR_PKG_DATA_DIR     ${GR_DATA_DIR}/${CMAKE_PROJECT_NAME})
set(GR_DOC_DIR          ${GR_DATA_DIR}/doc)
set(GR_PKG_DOC_DIR      ${GR_DOC_DIR}/${CMAKE_PROJECT_NAME})
set(GR_CONF_DIR         etc)
set(GR_PKG_CONF_DIR     ${GR_CONF_DIR}/${CMAKE_PROJECT_NAME}/conf.d)
set(GR_LIBEXEC_DIR      libexec)
set(GR_PKG_LIBEXEC_DIR  ${GR_LIBEXEC_DIR}/${CMAKE_PROJECT_NAME})
set(GRC_BLOCKS_DIR      ${GR_PKG_DATA_DIR}/grc/blocks)


if( ${CMAKE_SYSTEM_NAME} MATCHES "Linux")
    find_package(ALSA)
    find_package(USB)
    if(NOT LIBUSB_FOUND)
        message(FATAL_ERROR "libusb required to compile fcdproplus")
    endif()
endif()
find_package(PythonLibs 2)
find_package(SWIG)

if(NOT SWIG_FOUND)
    message(FATAL_ERROR "Swig required to build fcdproplus")
    else()    
	    message(STATUS "Swig version ${SWIG_VERSION} found")
endif()

find_package(Doxygen)
########################################################################
# Setup the include and linker paths
########################################################################
set(COMMON_INCLUDE_DIRS
    ${CMAKE_CURRENT_SOURCE_DIR}/include
    ${Boost_INCLUDE_DIRS}
    ${GNURADIO_RUNTIME_INCLUDE_DIRS}
)

set(COMMON_LIB_DIRS
    ${Boost_LIBRARY_DIRS}
    ${GNURADIO_BLOCKS_LIBRARY_DIRS}
)

if( ${CMAKE_SYSTEM_NAME} MATCHES "Linux")
    list(APPEND COMMON_INCLUDE_DIRS ${LIBUSB_INCLUDE_DIR})
    list(APPEND COMMON_LIB_DIRS ${LIBUSB_LIB_DIR})
endif()

# Set component parameters
set(GR_FCDPROPLUS_INCLUDE_DIRS ${CMAKE_CURRENT_SOURCE_DIR}/include)
set(GR_FCDPROPLUS_SWIG_INCLUDE_DIRS ${CMAKE_CURRENT_SOURCE_DIR}/swig CACHE INTERNAL "" FORCE)
########################################################################
# Create uninstall target
########################################################################
configure_file(
    ${CMAKE_SOURCE_DIR}/cmake/cmake_uninstall.cmake.in
    ${CMAKE_CURRENT_BINARY_DIR}/cmake_uninstall.cmake
@ONLY)

add_custom_target(uninstall
    ${CMAKE_COMMAND} -P ${CMAKE_CURRENT_BINARY_DIR}/cmake_uninstall.cmake
)

########################################################################
# Add subdirectories
########################################################################
add_subdirectory(include/fcdproplus)
add_subdirectory(lib)
add_subdirectory(swig)
add_subdirectory(python)
add_subdirectory(grc)
add_subdirectory(docs)
########################################################################
# Create Pkg Config File
########################################################################
# fake gnuradio cpack behavior as long as we don't use it directly
set(CPACK_PACKAGE_NAME "gnuradio-fcdproplus")
set(CPACK_PACKAGE_DESCRIPTION_SUMMARY "GNU Radio block for Funcube Dongle Pro+")
set(CPACK_PACKAGE_VERSION ${VERSION})

configure_file(
    ${CMAKE_CURRENT_SOURCE_DIR}/gnuradio-fcdproplus.pc.in
    ${CMAKE_CURRENT_BINARY_DIR}/gnuradio-fcdproplus.pc
@ONLY)

install(
    FILES ${CMAKE_CURRENT_BINARY_DIR}/gnuradio-fcdproplus.pc
    DESTINATION ${GR_LIBRARY_DIR}/pkgconfig
    COMPONENT "fcdproplus_devel"
)


########################################################################
# Print Summary
########################################################################
MESSAGE(STATUS "================ Build Summary =========================")
MESSAGE(STATUS "Building gr-fcdproplus : ${LIBVER} for ${CMAKE_SYSTEM_NAME} ")
MESSAGE(STATUS "Building for gnuradio  : ${Gnuradio_VERSION}")
MESSAGE(STATUS "Using CMAKE Module path: ${CMAKE_MODULE_PATH}" )
MESSAGE(STATUS "GNURADIO INCLUDES IN   : ${GNURADIO_RUNTIME_INCLUDE_DIRS}")
MESSAGE(STATUS "Using install prefix   : ${CMAKE_INSTALL_PREFIX}")
MESSAGE(STATUS "GNURADIO LIBS          : ${GNURADIO_AUDIO_LIBRARIES}")
if(HIDAPI_LIBRARY)
	  MESSAGE(STATUS "System Hidapi Lib ${HIDAPI_LIBRARY} is used")
else()	  
  MESSAGE(STATUS "Bundled hidapi is used")
endif()  
MESSAGE(STATUS "========================================================")

=== lib/CMakeLists.txt ===
# Copyright 2011-2014 Free Software Foundation, Inc.
#
# This file is part of GNU Radio
#
# GNU Radio is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 3, or (at your option)
# any later version.
#
# GNU Radio is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with GNU Radio; see the file COPYING.  If not, write to
# the Free Software Foundation, Inc., 51 Franklin Street,
# Boston, MA 02110-1301, USA.

########################################################################
# Setup library
########################################################################
include(GrPlatform) #define LIB_SUFFIX
include(GrMiscUtils)

link_directories(${COMMON_LIB_DIRS})

list(APPEND fcdproplus_sources
    fcdproplus_impl.cc
)


if(APPLE)
  FIND_LIBRARY(IOKIT_LIBRARY IOKit)
  list(APPEND fcdproplus_libs ${IOKIT_LIBRARY})
  FIND_LIBRARY(COREFOUNDATION_LIBRARY CoreFoundation)
  list(APPEND fcdproplus_libs ${COREFOUNDATION_LIBRARY})
else()
 list(APPEND fcdproplus_libs ${LIBUSB_LIBRARIES} )
endif()
if(HIDAPI_LIBRARY)
  add_library(gnuradio-fcdproplus SHARED ${fcdproplus_sources})
  list(APPEND fcdproplus_libs  ${HIDAPI_LIBRARY} )
  set_target_properties(gnuradio-fcdproplus PROPERTIES COMPILE_DEFINITIONS 
	  "SYSTEM_HIDAPI")
  include_directories(
	      ${COMMON_INCLUDE_DIRS} 
	      )
else()
#  MESSAGE(STATUS "Bundled hidapi is used")
  include_directories(
    ${CMAKE_CURRENT_SOURCE_DIR}/hid
    ${COMMON_INCLUDE_DIRS} 
  )
  if(APPLE)
    list(APPEND fcdproplus_sources
    ${CMAKE_CURRENT_SOURCE_DIR}/hid/hidmac.c)
  else()
   list(APPEND fcdproplus_sources ${CMAKE_CURRENT_SOURCE_DIR}/hid/hid.c)
  endif()
  add_library(gnuradio-fcdproplus SHARED ${fcdproplus_sources})
endif()


target_link_libraries(gnuradio-fcdproplus ${fcdproplus_libs} ${Boost_LIBRARIES}
  ${GNURADIO_RUNTIME_LIBRARIES} ${GNURADIO_BLOCKS_LIBRARIES}
  ${GNURADIO_AUDIO_LIBRARIES}
)

target_link_libraries(gnuradio-fcdproplus ${GNURADIO_PMT_LIBRARIES})
if(APPLE)
  SET_TARGET_PROPERTIES(gnuradio-fcdproplus PROPERTIES
      INSTALL_NAME_DIR "${CMAKE_INSTALL_PREFIX}/${GR_LIBRARY_DIR}")
endif(APPLE)

set_target_properties(gnuradio-fcdproplus PROPERTIES DEFINE_SYMBOL "gnuradio_fcdproplus_EXPORTS")
GR_LIBRARY_FOO(gnuradio-fcdproplus)

=== swig/CMakeLists.txt ===
# Copyright 2011-2014 Free Software Foundation, Inc.
#
# This file is part of GNU Radio
#
# GNU Radio is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 3, or (at your option)
# any later version.
#
# GNU Radio is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with GNU Radio; see the file COPYING.  If not, write to
# the Free Software Foundation, Inc., 51 Franklin Street,
# Boston, MA 02110-1301, USA.

########################################################################
# Include swig generation macros
########################################################################
find_package(SWIG)
find_package(PythonLibs)
if(NOT SWIG_FOUND OR NOT PYTHONLIBS_FOUND)
    return()
endif()
include(GrSwig)
include(GrPython)

########################################################################
# Setup swig generation
########################################################################
foreach(incdir ${GNURADIO_RUNTIME_INCLUDE_DIRS})
    list(APPEND GR_SWIG_INCLUDE_DIRS ${COMMON_INCLUDE_DIRS} ${incdir}/gnuradio/swig)
endforeach(incdir)

set(GR_SWIG_LIBRARIES gnuradio-fcdproplus)
set(GR_SWIG_DOC_FILE ${CMAKE_CURRENT_BINARY_DIR}/fcdproplus_swig_doc.i)
set(GR_SWIG_DOC_DIRS ${CMAKE_CURRENT_SOURCE_DIR}/../include)

GR_SWIG_MAKE(fcdproplus_swig fcdproplus_swig.i)

########################################################################
# Install the build swig module
########################################################################
GR_SWIG_INSTALL(TARGETS fcdproplus_swig DESTINATION ${GR_PYTHON_DIR}/fcdproplus)

########################################################################
# Install swig .i files for development
########################################################################
install(
    FILES
    fcdproplus_swig.i
    ${CMAKE_CURRENT_BINARY_DIR}/fcdproplus_swig_doc.i
    DESTINATION ${GR_INCLUDE_DIR}/fcdproplus/swig
)

=== debian/changelog ===
gr-fcdproplus (3.7.25.4b6464b-2~bpo8+2) jessie-backports; urgency=medium

  * Re-Rebuild for jessie-backports
    (ensure build with gnuradio 3.7.10.1-1~bpo8+1 on non-amd64 arch)

 -- A. Maitland Bottoms <bottoms@debian.org>  Sat, 15 Apr 2017 23:44:48 -0400

gr-fcdproplus (3.7.25.4b6464b-2~bpo8+1) jessie-backports; urgency=medium

  * Rebuild for jessie-backports

 -- A. Maitland Bottoms <bottoms@debian.org>  Sun, 04 Sep 2016 10:27:56 -0400

gr-fcdproplus (3.7.25.4b6464b-2) unstable; urgency=medium

  * Breaks/Replaces older library packages (Closes: #830754, #830787)

 -- A. Maitland Bottoms <bottoms@debian.org>  Mon, 11 Jul 2016 21:41:09 -0400

gr-fcdproplus (3.7.25.4b6464b-1) unstable; urgency=medium

  * v3.7.2-rc1-6-g4b6464b
  * build with gnuradio 3.7.10

 -- A. Maitland Bottoms <bottoms@debian.org>  Sat, 09 Jul 2016 17:01:59 -0400

gr-fcdproplus (3.7.24.cf5db38-5~bpo8+1) jessie-backports; urgency=medium

  * Rebuild for jessie-backports.

 -- A. Maitland Bottoms <bottoms@debian.org>  Mon, 25 Jan 2016 13:07:16 -0500

=== debian/control ===
Source: gr-fcdproplus
Section: science
Priority: optional
Maintainer: A. Maitland Bottoms <bottoms@debian.org>
Build-Depends: cmake,
               debhelper (>= 9.0.0~),
               doxygen,
               gnuradio (>>3.7.9.3),
               gnuradio-dev (>> 3.7.9.3),
               libasound2-dev,
               libboost-dev,
               libboost-filesystem-dev,
               libboost-system-dev,
               libhidapi-dev,
               liblog4cpp5-dev,
               libusb-1.0-0-dev,
               pkg-config,
               python,
               python-dev,
               swig
Standards-Version: 3.9.8
Homepage: https://github.com/dl1ksv/gr-fcdproplus
Vcs-Git: https://anonscm.debian.org/git/users/bottoms/pkg-gr-fcdproplus.git
Vcs-Browser: https://anonscm.debian.org/cgit/users/bottoms/pkg-gr-fcdproplus.git/

Package: gr-fcdproplus
Architecture: any
Depends: libgnuradio-fcdproplus3.7.10 (=${binary:Version}),
         ${misc:Depends},
         ${shlibs:Depends}
Recommends: gnuradio, gr-osmosdr, udev
Description: Funcube Dongle Pro Plus controller for GNU Radio
 Support hardware for software radio using the fcdproplus
 which provides sampled RF IQ data as a USB audio stereo
 data stream. Control is done over USB HID protocol.
 .
 Both the Funcube Dongle Pro and Pro+ are supported
 by this package. Previous Funcube Dongle device support
 is already included in gnuradio itself.
 .
 This package provides a Python library as well as
 a gnuradio companion source object.

Package: libgnuradio-fcdproplus3.7.10
Architecture: any
Pre-Depends: ${misc:Pre-Depends}
Depends: ${misc:Depends}, ${shlibs:Depends}
Recommends: gr-fcdproplus
Breaks: libgnuradio-fcdproplus0
Replaces: libgnuradio-fcdproplus0
Description: Funcube Dongle Pro Plus controller for GNU Radio (runtime)
 Support hardware for software radio using the fcdproplus
 which provides sampled RF IQ data as a USB audio stereo
 data stream. Control is done over USB HID protocol.
 .
 Both the Funcube Dongle Pro and Pro+ are supported
 by this package. Previous Funcube Dongle device support
 is already included in gnuradio itself.
 .
 This package provides a shared library.

=== debian/rules ===
#!/usr/bin/make -f
DEB_HOST_MULTIARCH ?= $(shell dpkg-architecture -qDEB_HOST_MULTIARCH)
export DEB_HOST_MULTIARCH
DEB_DEBIAN_DIR=$(dir $(firstword $(MAKEFILE_LIST)))
VER=$(shell dpkg-parsechangelog -l$(DEB_DEBIAN_DIR)/changelog \
              | sed -rne 's,^Version: ([^-]+).*,\1,p')
GITREV=$(shell echo $(VER) | sed -rne 's,[0-9]+\.[0-9]+\.[0-9]+\.[0-9]+\.([0-9]+),\1,p')

%:
	dh $@

override_dh_auto_configure:
	dh_auto_configure -- -DLIB_SUFFIX="/$(DEB_HOST_MULTIARCH)" -DCMAKE_BUILD_TYPE="Release"

override_dh_install:
	rm -f debian/tmp/usr/lib/python2.7/dist-packages/fcdproplus/*.pyc
	rm -f debian/tmp/usr/lib/python2.7/dist-packages/fcdproplus/*.pyo
	mkdir -p debian/tmp/usr/include/fcdproplus
	cp include/fcdproplus/*.h debian/tmp/usr/include/fcdproplus/
	dh_install

get-orig-source:
	git clone https://github.com/dl1ksv/gr-fcdproplus
	cd gr-fcdproplus && git archive --format=tar --prefix=gr-fcdproplus-$(VER)/  $(GITREV) | xz > ../gr-fcdproplus_$(VER).orig.tar.xz
	rm -rf gr-fcdproplus

## gr-fcdproplus 3.8~20190817

=== CMakeLists.txt ===
# Copyright 2011-2014 Free Software Foundation, Inc.
#
# This file is part of GNU Radio
#
# GNU Radio is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 3, or (at your option)
# any later version.
#
# GNU Radio is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with GNU Radio; see the file COPYING.  If not, write to
# the Free Software Foundation, Inc., 51 Franklin Street,
# Boston, MA 02110-1301, USA.


########################################################################
# Project setup
########################################################################
########################################################################
#
# First look in the install directory for package config of gnuradio
#
########################################################################
set( ENV{PKG_CONFIG_PATH} "${CMAKE_INSTALL_PREFIX}/lib/pkgconfig:$ENV{PKG_CONFIG_PATH}")

cmake_minimum_required(VERSION 3.8)
project(gr-fcdproplus CXX C)

#install to PyBOMBS target prefix if defined
if(DEFINED ENV{PYBOMBS_PREFIX})
    set(CMAKE_INSTALL_PREFIX $ENV{PYBOMBS_PREFIX})
    message(STATUS "PyBOMBS installed GNU Radio. Setting CMAKE_INSTALL_PREFIX to $ENV{PYBOMBS_PREFIX}")
endif()

#select the release build type by default to get optimization flags
if(NOT CMAKE_BUILD_TYPE)
   set(CMAKE_BUILD_TYPE "Release")
   message(STATUS "Build type not specified: defaulting to release.")
endif(NOT CMAKE_BUILD_TYPE)
set(CMAKE_BUILD_TYPE ${CMAKE_BUILD_TYPE} CACHE STRING "")

########################################################################
#
# setup version info
#
########################################################################

set(VERSION_MAJOR 3)
set(VERSION_API 8)
SET(VERSION_ABI 0)
SET(VERSION_PATCH 0)

cmake_policy(SET CMP0011 NEW)
########################################################################
# Compiler specific setup
########################################################################
#if(CMAKE_COMPILER_IS_GNUCXX AND NOT WIN32)
#    #http://gcc.gnu.org/wiki/Visibility
#    add_definitions(-fvisibility=hidden)
#  endif()
if((CMAKE_CXX_COMPILER_ID MATCHES "Clang" OR
    CMAKE_CXX_COMPILER_ID STREQUAL "GNU")
    AND NOT WIN32)
    #http://gcc.gnu.org/wiki/Visibility
    add_definitions(-fvisibility=hidden)
endif()
########################################################################
# Find gnuradio build dependencies
########################################################################

find_package(Gnuradio "3.8" REQUIRED audio blocks PATHS ${CMAKE_INSTALL_PREFIX} )
list(INSERT CMAKE_MODULE_PATH 0 "${CMAKE_SOURCE_DIR}/cmake/Modules")
FIND_LIBRARY(HIDAPI_LIBRARY hidapi-libusb)

include(GrVersion)

########################################################################
# Find fcd(proplus) dependencies
########################################################################
if( ${CMAKE_SYSTEM_NAME} MATCHES "Linux")
    find_package(USB)
    if(NOT LIBUSB_FOUND)
        message(FATAL_ERROR "libusb required to compile fcdproplus")
    endif()
endif()
########################################################################
# Install directories
########################################################################
include(GrPlatform) #define LIB_SUFFIX
if(NOT CMAKE_MODULES_DIR)
  SET(CMAKE_MODULES_DIR lib${LIB_SUFFIX}/cmake)
endif(NOT CMAKE_MODULES_DIR)

set(GR_RUNTIME_DIR      bin)
set(GR_LIBRARY_DIR      lib${LIB_SUFFIX})
set(GR_INCLUDE_DIR      include/fcdproplus)
set(GR_DATA_DIR         share)
set(GR_PKG_DATA_DIR     ${CMAKE_INSTALL_PREFIX}/${GR_DATA_DIR}/${CMAKE_PROJECT_NAME})
set(GR_DOC_DIR          ${GR_DATA_DIR}/doc)
set(GR_PKG_DOC_DIR      ${GR_DOC_DIR}/${CMAKE_PROJECT_NAME})
set(GR_CONF_DIR         etc)
set(GR_PKG_CONF_DIR     ${GR_CONF_DIR}/${CMAKE_PROJECT_NAME}/conf.d)
set(GR_LIBEXEC_DIR      libexec)
set(GR_PKG_LIBEXEC_DIR  ${GR_LIBEXEC_DIR}/${CMAKE_PROJECT_NAME})
set(GRC_BLOCKS_DIR      ${CMAKE_INSTALL_PREFIX}/${GR_DATA_DIR}/gnuradio/grc/blocks)

SET(GR_CMAKE_DIR        ${CMAKE_MODULES_DIR}/gr-fcdproplus)

########################################################################
# On Apple only, set install name and use rpath correctly, if not already set
########################################################################
if(APPLE)
    if(NOT CMAKE_INSTALL_NAME_DIR)
        set(CMAKE_INSTALL_NAME_DIR
            ${CMAKE_INSTALL_PREFIX}/${GR_LIBRARY_DIR} CACHE
            PATH "Library Install Name Destination Directory" FORCE)
    endif(NOT CMAKE_INSTALL_NAME_DIR)
    if(NOT CMAKE_INSTALL_RPATH)
        set(CMAKE_INSTALL_RPATH
            ${CMAKE_INSTALL_PREFIX}/${GR_LIBRARY_DIR} CACHE
            PATH "Library Install RPath" FORCE)
    endif(NOT CMAKE_INSTALL_RPATH)
    if(NOT CMAKE_BUILD_WITH_INSTALL_RPATH)
        set(CMAKE_BUILD_WITH_INSTALL_RPATH ON CACHE
            BOOL "Do Build Using Library Install RPath" FORCE)
    endif(NOT CMAKE_BUILD_WITH_INSTALL_RPATH)
endif(APPLE)

########################################################################
# Setup doxygen option
########################################################################
find_package(Doxygen)
if(DOXYGEN_FOUND)
        option(ENABLE_DOXYGEN "Build docs using Doxygen" ON)
else(DOXYGEN_FOUND)
        option(ENABLE_DOXYGEN "Build docs using Doxygen" OFF)
endif(DOXYGEN_FOUND)

########################################################################
# Create uninstall target
########################################################################
configure_file(
    ${CMAKE_SOURCE_DIR}/cmake/cmake_uninstall.cmake.in
    ${CMAKE_CURRENT_BINARY_DIR}/cmake_uninstall.cmake
@ONLY)

add_custom_target(uninstall
    ${CMAKE_COMMAND} -P ${CMAKE_CURRENT_BINARY_DIR}/cmake_uninstall.cmake
)

########################################################################
# Add subdirectories
########################################################################
add_subdirectory(include/fcdproplus)
add_subdirectory(lib)
add_subdirectory(swig)
add_subdirectory(python)
add_subdirectory(grc)
add_subdirectory(docs)
########################################################################
# Create Pkg Config File
########################################################################
# fake gnuradio cpack behavior as long as we don't use it directly
set(CPACK_PACKAGE_NAME "gnuradio-fcdproplus")
set(CPACK_PACKAGE_DESCRIPTION_SUMMARY "GNU Radio block for Funcube Dongle Pro+")
set(CPACK_PACKAGE_VERSION ${VERSION})

configure_file(
    ${CMAKE_CURRENT_SOURCE_DIR}/gnuradio-fcdproplus.pc.in
    ${CMAKE_CURRENT_BINARY_DIR}/gnuradio-fcdproplus.pc
@ONLY)

install(
    FILES ${CMAKE_CURRENT_BINARY_DIR}/gnuradio-fcdproplus.pc
    DESTINATION ${GR_LIBRARY_DIR}/pkgconfig
    COMPONENT "fcdproplus_devel"
)


########################################################################
# Print Summary
########################################################################
MESSAGE(STATUS "================ Build Summary =========================")
MESSAGE(STATUS "Building gr-fcdproplus  : ${LIBVER} for ${CMAKE_SYSTEM_NAME} ")
MESSAGE(STATUS "Building for gnuradio   : ${Gnuradio_VERSION}")
MESSAGE(STATUS "Using CMAKE Module path : ${CMAKE_MODULE_PATH}" )
MESSAGE(STATUS "CMake Modules Dir       : ${CMAKE_MODULES_DIR}" )
MESSAGE(STATUS "fcdproplus INCLUDES     : ${GR_INCLUDE_DIR}")
MESSAGE(STATUS "Using install prefix    : ${CMAKE_INSTALL_PREFIX}")
MESSAGE(STATUS "Installing grc files to : ${GRC_BLOCKS_DIR}")
if(HIDAPI_LIBRARY)
	  MESSAGE(STATUS "System Hidapi Lib ${HIDAPI_LIBRARY} is used")
else()	  
  MESSAGE(STATUS "Bundled hidapi is used")
endif()  
MESSAGE(STATUS "========================================================")

=== docs/CMakeLists.txt ===
# Copyright 2011 Free Software Foundation, Inc.
#
# This file is part of GNU Radio
#
# GNU Radio is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 3, or (at your option)
# any later version.
#
# GNU Radio is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with GNU Radio; see the file COPYING.  If not, write to
# the Free Software Foundation, Inc., 51 Franklin Street,
# Boston, MA 02110-1301, USA.

########################################################################
# Setup dependencies
########################################################################
find_package(Doxygen)

########################################################################
# Begin conditional configuration
########################################################################
if(ENABLE_DOXYGEN)

########################################################################
# Add subdirectories
########################################################################
add_subdirectory(doxygen)

endif(ENABLE_DOXYGEN)

=== grc/CMakeLists.txt ===
# Copyright 2011 Free Software Foundation, Inc.
#
# This file is part of GNU Radio
#
# GNU Radio is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 3, or (at your option)
# any later version.
#
# GNU Radio is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with GNU Radio; see the file COPYING.  If not, write to
# the Free Software Foundation, Inc., 51 Franklin Street,
# Boston, MA 02110-1301, USA.

if(${CMAKE_SYSTEM_NAME} MATCHES "Darwin")
  set(DEVICE_STRING "FUNcube Dongle V2.0")
else()
  set(DEVICE_STRING "''")
endif()
configure_file (
	fcdproplus.block.yml.in
	fcdproplus.block.yml
	ESCAPE_QUOTES @ONLY
)

install(FILES
	${CMAKE_BINARY_DIR}/grc/fcdproplus.block.yml
  fcdproplus_control.block.yml
  fcd_control.block.yml
  fcd.block.yml
	DESTINATION "${GRC_BLOCKS_DIR}"

)

=== lib/CMakeLists.txt ===
# Copyright 2011-2014 Free Software Foundation, Inc.
#
# This file is part of GNU Radio
#
# GNU Radio is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 3, or (at your option)
# any later version.
#
# GNU Radio is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with GNU Radio; see the file COPYING.  If not, write to
# the Free Software Foundation, Inc., 51 Franklin Street,
# Boston, MA 02110-1301, USA.

########################################################################
# Setup library
########################################################################
include(GrPlatform) #define LIB_SUFFIX
include(GrMiscUtils)

list(APPEND fcdproplus_sources
    fcdproplus_impl.cc
    fcdpp_control_impl.cc
    fcd_control_impl.cc
    fcd_impl.cc
)

add_library(gnuradio-fcdproplus SHARED ${fcdproplus_sources})
list(APPEND fcdproplus_libs ${LIBUSB_LIBRARIES} )

if(HIDAPI_LIBRARY)
    MESSAGE(STATUS "System Hidapi will be used")
    list(APPEND fcdproplus_libs  ${HIDAPI_LIBRARY} )
    find_path(HIDAPI_INCLUDES NAMES "hidapi.h"
        HINTS /usr/include/hidapi
        PATHS
        /usr/include
        /usr/local/include
    )
else ()
    list(APPEND fcdproplus_sources ${CMAKE_CURRENT_SOURCE_DIR}/hid/hid.c)
    set(HIDAPI_INCLUDES "${CMAKE_CURRENT_SOURCE_DIR}/hid")
endif()
target_link_libraries(gnuradio-fcdproplus gnuradio::gnuradio-audio gnuradio::gnuradio-blocks ${fcdproplus_libs})
target_include_directories(gnuradio-fcdproplus
    PUBLIC $<BUILD_INTERFACE:${CMAKE_CURRENT_SOURCE_DIR}/../include>
    PUBLIC $<BUILD_INTERFACE:${HIDAPI_INCLUDES}>
    PUBLIC $<INSTALL_INTERFACE:include>
)

if(APPLE)
  SET_TARGET_PROPERTIES(gnuradio-fcdproplus PROPERTIES
      INSTALL_NAME_DIR "${CMAKE_INSTALL_PREFIX}/${GR_LIBRARY_DIR}")
endif(APPLE)

set_target_properties(gnuradio-fcdproplus PROPERTIES DEFINE_SYMBOL "gnuradio_fcdproplus_EXPORTS")
GR_LIBRARY_FOO(gnuradio-fcdproplus)

=== swig/CMakeLists.txt ===
--- 
+++ 
@@ -31,9 +31,8 @@
 ########################################################################
 # Setup swig generation
 ########################################################################
-foreach(incdir ${GNURADIO_RUNTIME_INCLUDE_DIRS})
-    list(APPEND GR_SWIG_INCLUDE_DIRS ${COMMON_INCLUDE_DIRS} ${incdir}/gnuradio/swig)
-endforeach(incdir)
+set(GR_SWIG_INCLUDE_DIRS $<TARGET_PROPERTY:gnuradio::runtime_swig,INTERFACE_INCLUDE_DIRECTORIES>)
+set(GR_SWIG_TARGET_DEPS gnuradio::runtime_swig)
 
 set(GR_SWIG_LIBRARIES gnuradio-fcdproplus)
 set(GR_SWIG_DOC_FILE ${CMAKE_CURRENT_BINARY_DIR}/fcdproplus_swig_doc.i)

=== docs/doxygen/CMakeLists.txt ===
# Copyright 2011 Free Software Foundation, Inc.
#
# This file is part of GNU Radio
#
# GNU Radio is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 3, or (at your option)
# any later version.
#
# GNU Radio is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with GNU Radio; see the file COPYING.  If not, write to
# the Free Software Foundation, Inc., 51 Franklin Street,
# Boston, MA 02110-1301, USA.

########################################################################
# Create the doxygen configuration file
########################################################################
file(TO_NATIVE_PATH ${CMAKE_SOURCE_DIR} top_srcdir)
file(TO_NATIVE_PATH ${CMAKE_BINARY_DIR} top_builddir)
file(TO_NATIVE_PATH ${CMAKE_SOURCE_DIR} abs_top_srcdir)
file(TO_NATIVE_PATH ${CMAKE_BINARY_DIR} abs_top_builddir)

set(HAVE_DOT ${DOXYGEN_DOT_FOUND})
set(enable_html_docs YES)
set(enable_latex_docs NO)
set(enable_xml_docs YES)

configure_file( 
    ${DOXY_FILE_PATH}/Doxyfile.in
    ${CMAKE_CURRENT_BINARY_DIR}/Doxyfile
@ONLY)

set(BUILT_DIRS ${CMAKE_CURRENT_BINARY_DIR}/xml ${CMAKE_CURRENT_BINARY_DIR}/html)

########################################################################
# Make and install doxygen docs
########################################################################
add_custom_command(
    OUTPUT ${BUILT_DIRS}
    COMMAND ${DOXYGEN_EXECUTABLE} ${CMAKE_CURRENT_BINARY_DIR}/Doxyfile
    WORKING_DIRECTORY ${CMAKE_CURRENT_BINARY_DIR}
    COMMENT "Generating documentation with doxygen"
)

add_custom_target(doxygen_target ALL DEPENDS ${BUILT_DIRS})

install(DIRECTORY ${BUILT_DIRS} DESTINATION ${GR_PKG_DOC_DIR})

=== include/fcdproplus/CMakeLists.txt ===
# Copyright 2011,2012 Free Software Foundation, Inc.
#
# This file is part of GNU Radio
#
# GNU Radio is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 3, or (at your option)
# any later version.
#
# GNU Radio is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with GNU Radio; see the file COPYING.  If not, write to
# the Free Software Foundation, Inc., 51 Franklin Street,
# Boston, MA 02110-1301, USA.

########################################################################
# Install public header files
########################################################################
install(FILES
    api.h
    fcdproplus.h
    fcdpp_control.h
    fcd_control.h
    fcd.h
    DESTINATION include/fcdproplus
)

=== debian/changelog ===
gr-fcdproplus (3.8~20190817-3~mx19+1) mx; urgency=medium

  * Initial packaging of upstream release for MX 19.
  * Changed DB from debhelper (>= 12~) to debhelper-compat (=12)
  * Removed debian/compat file

 -- ”SwampRabbit” <swamprabbit@mxlinux.org>  Sun, 26 Apr 2020 00:45:51 -0400

gr-fcdproplus (3.8~20190817-3) unstable; urgency=medium

  * depend upon dh-python since python3-dev no longer does
  * also add depends on liborc-0.4-dev (Closes: #948937)
    thanks peter!

 -- A. Maitland Bottoms <bottoms@debian.org>  Wed, 15 Jan 2020 00:06:08 -0500

gr-fcdproplus (3.8~20190817-2) unstable; urgency=medium

  * new watch file. Thanks Kali folk! (Closes: #888853)
  * upload to unstable

 -- A. Maitland Bottoms <bottoms@debian.org>  Wed, 28 Aug 2019 19:08:56 -0400

gr-fcdproplus (3.8~20190817-1) experimental; urgency=medium

  * New upstream 3.8 port

 -- A. Maitland Bottoms <bottoms@debian.org>  Sat, 17 Aug 2019 21:03:19 -0400

gr-fcdproplus (3.7.25.4b6464b-5) unstable; urgency=medium

  * add breaks/replaces line to hint upgrade (Closes: #875875)

 -- A. Maitland Bottoms <bottoms@debian.org>  Sat, 16 Sep 2017 03:25:39 -0400

gr-fcdproplus (3.7.25.4b6464b-4) unstable; urgency=medium

  * install .pc file correctly (Closes: #875436)
  * install AppStream metainfo.xml file

 -- A. Maitland Bottoms <bottoms@debian.org>  Thu, 14 Sep 2017 17:56:18 -0400

gr-fcdproplus (3.7.25.4b6464b-3) unstable; urgency=medium

  * build with gnuradio 3.7.10

 -- A. Maitland Bottoms <bottoms@debian.org>  Mon, 04 Sep 2017 00:02:30 -0400

=== debian/control ===
Source: gr-fcdproplus
Section: hamradio
Priority: optional
Maintainer: SwampRabbit <swamprabbit@mxlinux.org>
XSBC-Original-Maintainer: Debian Hamradio Maintainers <debian-hams@lists.debian.org>
Uploaders: A. Maitland Bottoms <bottoms@debian.org>
Build-Depends: cmake,
               debhelper-compat (=12),
	       dh-python,
               doxygen,
               gnuradio (>=3.8),
               gnuradio-dev (>> 3.8),
               libasound2-dev,
               libboost-dev,
               libboost-filesystem-dev,
	       libboost-program-options-dev,
	       libboost-regex-dev,
               libboost-system-dev,
	       libboost-thread-dev,
	       libgmp-dev,
               libhidapi-dev,
	       libjack-dev,
               liblog4cpp5-dev,
	       liborc-0.4-dev,
	       libpulse-dev,
               libusb-1.0-0-dev,
               pkg-config,
	       portaudio19-dev,
               python3-dev,
	       python3-six,
               swig
Standards-Version: 4.4.0
Homepage: https://github.com/dl1ksv/gr-fcdproplus
Vcs-Browser: https://salsa.debian.org/debian-hamradio-team/pkg-gr-fcdproplus
Vcs-Git: https://salsa.debian.org/debian-hamradio-team/pkg-gr-fcdproplus.git

Package: gr-fcdproplus
Architecture: any
Depends: ${python3:Depends},
	 libgnuradio-fcdproplus3.8.0 (=${binary:Version}),
         ${misc:Depends},
         ${shlibs:Depends}
Recommends: gnuradio, gr-osmosdr, udev
Description: Funcube Dongle Pro Plus controller for GNU Radio
 Support hardware for software radio using the fcdproplus
 which provides sampled RF IQ data as a USB audio stereo
 data stream. Control is done over USB HID protocol.
 .
 Both the Funcube Dongle Pro and Pro+ are supported
 by this package. Previous Funcube Dongle device support
 is already included in gnuradio itself.
 .
 This package provides a Python library as well as
 a gnuradio companion source object.

Package: libgnuradio-fcdproplus3.8.0
Architecture: any
Pre-Depends: ${misc:Pre-Depends}
Depends: ${misc:Depends}, ${shlibs:Depends}
Recommends: gr-fcdproplus
Description: Funcube Dongle Pro Plus controller for GNU Radio (runtime)
 Support hardware for software radio using the fcdproplus
 which provides sampled RF IQ data as a USB audio stereo
 data stream. Control is done over USB HID protocol.
 .
 Both the Funcube Dongle Pro and Pro+ are supported
 by this package. Previous Funcube Dongle device support
 is already included in gnuradio itself.
 .
 This package provides a shared library.

=== debian/rules ===
#!/usr/bin/make -f
DEB_HOST_MULTIARCH ?= $(shell dpkg-architecture -qDEB_HOST_MULTIARCH)
export DEB_HOST_MULTIARCH
DEB_DEBIAN_DIR=$(dir $(firstword $(MAKEFILE_LIST)))
VER=$(shell dpkg-parsechangelog -l$(DEB_DEBIAN_DIR)/changelog \
              | sed -rne 's,^Version: ([^-]+).*,\1,p')
GITREV=$(shell echo $(VER) | sed -rne 's,[0-9]+\.[0-9]+\.[0-9]+\.[0-9]+\.([0-9]+),\1,p')

%:
	dh $@ --with python3

override_dh_auto_configure:
	dh_auto_configure -- -DLIB_SUFFIX="/$(DEB_HOST_MULTIARCH)" -DCMAKE_BUILD_TYPE="Release"

override_dh_install:
	rm -f debian/tmp/usr/lib/python3.7/dist-packages/fcdproplus/*.pyc
	rm -f debian/tmp/usr/lib/python3.7/dist-packages/fcdproplus/*.pyo
	#mkdir -p debian/tmp/usr/include/fcdproplus
	#cp include/fcdproplus/*.h debian/tmp/usr/include/fcdproplus/
	dh_install

get-orig-source:
	git clone https://github.com/dl1ksv/gr-fcdproplus
	cd gr-fcdproplus && git archive --format=tar --prefix=gr-fcdproplus-$(VER)/  $(GITREV) | xz > ../gr-fcdproplus_$(VER).orig.tar.xz
	rm -rf gr-fcdproplus

override_dh_strip:
	dh_strip --no-automatic-dbgsym
